The OpenNET Project / Index page

[ новости /+++ | форум | wiki | теги | ]

Доступен релиз системной библиотеки Glibc 2.11

04.11.2009 09:49

Вышел релиз системной библиотеки GNU C Library (glibc) 2.11. Из новшеств можно отметить:

  • Новые функции, определенные в последнем варианте стандарта POSIX: execvpe, pthread_sigqueue, mkstemps, mkstemps64, mkostemps и mkostemps64;
  • Добавлены специально оптимизированные для архитектуры x86-64 варианты функций: strstr, strcasestr, memcmp, strcspn, strpbrk, strspn, strcpy, stpcpy, strncpy, strcmp (задействованы инструкции SSE2, SSE4.2), strncmp (SSE2, SSE4.2), strchr (SSE4.2), strrchr (SSE4.2), strlen, rawmemchr, strcmp (SSSE3), strncmp (SSSE3);
  • Добавлены специально оптимизированные для архитектуры x86 варианты функций: strlen, strcspn, strspn, strpbrk, strstr, strcasestr;
  • Выполнение вызова longjmp теперь возвращается с ошибкой, если при его работе будет обнаружено создание инициализированных областей стека;
  • STT_GNU_IFUNC теперь поддерживается в статически скомпонованных исполняемых файлах. Для архитектуры PPC реализована поддержка STT_GNU_IFUNC. Добавлена поддержка STB_GNU_UNIQUE;
  • Добавлена поддержка fma инструкций в AVX расширении для архитектуры x86-64. В ld.so с использованием возможностей AVX реализованы средства аудита;
  • В код DNS резолвера добавлен режим повторного запроса: если два DNS обращения c одного порта не могут быть выполнены, сокет закрывается и осуществляется еще одна попытка, но с заново созданным сокетом. Включить данный режим можно через указание опции 'single-request-reopen' в /etc/resolv.conf. Кроме того, в резолвере реализована поддержка флага RES_USE_DNSSEC для осуществления запросов с подтверждением;
  • Повышена эффективность работы PI-мьютексов, в случае если ядро ОС поддерживает операцию перераспределения элементов очереди к PI-фьютексам. Для архитектуры x86-64 добавлена поддержка NPTL нитей;
  • Добавлены новые локали: ps_AF, my_MM.


  1. Главная ссылка к новости (http://sourceware.org/ml/libc-...)
  2. OpenNews: В glibc остается неисправленной уязвимость, найденная больше года назад
  3. OpenNews: Релиз системной библиотеки glibc 2.10 и генератора файлов сборки Automake 1.11
  4. OpenNews: Проект Debian GNU/Linux планирует заменить GNU C Library на EGLIBC
Лицензия: CC-BY
Тип: Программы
Короткая ссылка: https://opennet.ru/24106-glibc
Ключевые слова: glibc
При перепечатке указание ссылки на opennet.ru обязательно
Обсуждение (11) Ajax | 1 уровень | Линейный | +/- | Раскрыть всё | RSS
  • 1.1, Zenitur (?), 10:06, 04/11/2009 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    У меня есть несколько вопросов к знатокам:
    Безопасно ли обновлять эту библиотеку самому? Кто-то мне говорит, что это самое безболезненное из того, что можно обновить в системе. Кто-то - что могут засбоить все программы. Кто-то - что засбоят они только при даунгрейде... Кому верить?
    Второй вопрос. бенчмарки говорят мне, что процессор поддерживает MMX+, 3DNOW+, SSE, SSE2, SSE3 и SSE4A. Что такое SSE4A? Ничего что может разъяснить, вроде сисофта сандры, я не нашёл, поиском нашёл только прайс-листы.
     
     
  • 2.2, hatewindows (ok), 11:21, 04/11/2009 [^] [^^] [^^^] [ответить]  
  • +3 +/
    SSE4A это альтернативная технология интеловскому SSE4, разаработанная АМД и впервые внедренная в 4-х ядерных Phenom'ах. Межу собой эти реализации несовместимы, в отличие от SSE..SSE3.

    Насчет обновляться или нет, все зависит от дистрибутива, потому как процесс обновления и восстановления (в случае неполадок) у дистрибутивов с пакетной системой установки будет намного легче от установки из исходников. Я советую подождать пару тройку дней, чтобы, мейнтайнеры смогли внсти изменения в свои пакеты, если обнаружаться косяки.

     
  • 2.4, anon (?), 13:26, 04/11/2009 [^] [^^] [^^^] [ответить]  
  • +/
    Что-что, а именно эту библиотеку лучше самому не трогать, т.к. от нее зависят все исполняемые файлы с динамической линковкой. И сделав что-то неверно можно довести систему до состояния полной незагружаемости далее ядра/initrd.
     
  • 2.5, GArik (?), 16:43, 04/11/2009 [^] [^^] [^^^] [ответить]  
  • +/
    Сначала хотя бы здесь почитайте:
    http://www.gnu.org/software/libc/resources.html#building

    Я бы советовал не трогать.

     
  • 2.11, darkk (?), 21:29, 03/12/2009 [^] [^^] [^^^] [ответить]  
  • +/
    Моя инсталляция gentoo пережила не одно обновление Glibc.

    Конечно же, перед массовым обновлением критичных вещей собирается слепок системы в бинарные пакеты, которые можно развернуть загрузившись в /bin/sh на initrd.

     

  • 1.3, Alan Makoev (ok), 12:35, 04/11/2009 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    У меня как-то возникла нужда в новой glibc (на тот момент 2.7, в системе была 2.4), когда поставил - проги перестали запускаться, перекомпилять мир ни времени, ни желания не было, вернул всё взад.
     
  • 1.6, nim (?), 19:47, 05/11/2009 [ответить] [﹢﹢﹢] [ · · · ]  
  • +/
    Интересен вопрос с обновлением. Допустим я запустил гномовский калькулятор, а потом поставил новую версию gtk, причём старая затёрлась. Каким образом в системе решается такая проблема. Что будет если я запущу после этого ещё один калькулятор?
     
     
  • 2.7, Andrey Mitrofanov (?), 20:27, 05/11/2009 [^] [^^] [^^^] [ответить]  
  • +/
    Вы уверены, что "в системе" будет при этом какая-то "проблема"? :-O
     
     
  • 3.8, pavel_simple (ok), 20:28, 05/11/2009 [^] [^^] [^^^] [ответить]  
  • +/
    >Вы уверены, что "в системе" будет при этом какая-то "проблема"? :-O

    целых ДВА калькулятора? -- нет иксы такое не тянут

     
  • 2.9, BSA (?), 22:56, 05/11/2009 [^] [^^] [^^^] [ответить]  
  • +/
    Все очень просто. В *nix фактическое удаление с диска происходит в тот момент, когда закрывается последний открытый дескриптор файла, помеченного на удаление (unlink убирает файл из каталога, но не стирает фактически, если он хоть кем-нибудь открыт). Поэтому первый экземпляр калькулятора будет работать как ни в чем не бывало. Когда ты запускаешь второй, то он уже цепляет новую версию библиотеки, так как файлы первой открыть уже нельзя (их просто нет ни в одном каталоге, хотя место на диске под них еще зарезервировано). В итоге, будут работать две версии библиотек одновременно.
     
     
  • 3.10, anonymous (??), 22:26, 06/11/2009 [^] [^^] [^^^] [ответить]  
  • +/
    Ну это где как. В линуксе можно, а вот попробуйте в солярке libc переписать :p (не надо говорить про глупость ситуации - это реальность, в libc солярки бывают баги и апдейты иногда могут поставить новую версию). Внутренний api для этого есть, а вот попробуйте из командной строки заменить одну версию на другую..
     
     Добавить комментарий
    Имя:
    E-Mail:
    Текст:



    Спонсоры:
    Inferno Solutions
    Hosting by Hoster.ru
    Хостинг:

    Закладки на сайте
    Проследить за страницей
    Created 1996-2020 by Maxim Chirkov
    Добавить, Поддержать, Вебмастеру